calc_weights <-
function(p0,theta0){
  

  m0=length(p0)

  
  
    mu0=0
  
    #mu ist zahl z.b 0, theta ist vektor mit sd's und p ebenfalls vektor aber mit gewichten
    dnormix_0   <- function(x) {  
      erg=0
      for (i in 1:m0)
        erg = erg + p0[i]* dnorm(x,mean=mu0,sd=theta0[i])
      return(erg)
    }

    delta     <- function(x,h) { (dnorm(x,mean=mu0,sd=theta0[h]) - dnorm(x,mean=mu0,sd=theta0[m0]))/dnormix_0(x)  }
 
    f_strich  <- function(x,h,mu=mu0)   { (mu^2-theta0[h]^2-2*mu*x+x^2)/theta0[h]^3*dnorm(x,mu,theta0[h]) }
    f_2strich <- function(x,h,mu=mu0)   { (mu^4+2*theta0[h]^4-4*mu^3*x-5*theta0[h]^2*x^2+x^4+mu^2*(-5*theta0[h]^2+6*x^2)+2*mu*(5*theta0[h]^2*x-2*x^3))/theta0[h]^6*dnorm(x,mu,theta0[h]) }
    Y_strich  <- function(x,h) { f_strich(x,h)/ dnormix_0(x)}
    Y_2strich <- function(x,h) { f_2strich(x,h)/dnormix_0(x)}
    
    #erzeuge iid Daten
    daten=c()
    n=100000
    for(j in 1:m0){
      daten=c(daten,rnorm(floor(n*p0[j]),mean=0,sd=theta0[j]) )
    }    
    n=length(daten)
  
  

  #initialisiere liste fr Funktionen 
  l=list()
  
  
  #Simulation fr Sigma22_tilde   
    b_mat = matrix(ncol=(3*m0-1),nrow=n)

    for(i in 1:(m0-1))
      b_mat[,i] = delta(daten,i)
    
    for(i in 1:m0){
      j = i+(m0-1)
      b_mat[,j] = Y_strich(daten,i)
    } 
      
    for(i in 1:m0){
      j=i+(2*m0-1)
      b_mat[,j] = Y_2strich(daten,i)
    }    

    Sigma=cov(b_mat)
    
    #return(Sigma)

    Sigma11 = Sigma[1:(2*m0-1),1:(2*m0-1)]
    Sigma21 = Sigma[(2*m0):(3*m0-1),1:(2*m0-1)]
    Sigma12 = t(Sigma21)
    Sigma22 = Sigma[(2*m0):(3*m0-1),(2*m0):(3*m0-1)]
    
    Sigma22_s <-  Sigma22 - Sigma21 %*% solve(Sigma11) %*% Sigma12
    
    #return(Sigma22_s)

  #####
  # ALT: Kovarianz-Matrix +ber numerische Integration
  #####
  
  #xrange=50
  
  #berechne Sigma11
  #Sigma11 = matrix(NA,nrow=2*m0-1,ncol=2*m0-1)
  
  #1 Cov Delta
  #for(i in 1:(m0-1)){
  # for(j in 1:(m0-1)){
  #  zv =  function(x) return( delta(x,i) * delta(x,j) )
  #  g = function(x) return(zv(x) * dnormix_0(x))
  #  Sigma11[i,j] =  integrate(g,lower=-xrange,upper=xrange)$value
  # }
  #}

  
  #2 Cov Delta  Y '
  #for(i in 1:(m0-1)){
  # for(j in 1:m0){
  #  zv =  function(x) return( delta(x,i) * Y_strich(x,j) )
  #  g = function(x) return(zv(x) * dnormix_0(x))
  #  Sigma11[i,j+(m0-1)] =  integrate(g,lower=-xrange,upper=xrange)$value
  #  Sigma11[j+(m0-1),i]   = Sigma11[i,j+(m0-1)]
  # }
  #}
  
  #3 Cov Y'
  #for(i in 1:m0){
  # for(j in 1:m0){
  #  zv =  function(x) return( Y_strich(x,i) * Y_strich(x,j) )
  #  g = function(x) return(zv(x) * dnormix_0(x))
  #  Sigma11[i+(m0-1),j+(m0-1)] =  integrate(g,lower=-xrange,upper=xrange)$value
  # }
  #}
  
  
  #berechne Sigma22
  #Sigma22 = matrix(NA,nrow=m0,ncol=m0)
  #1 Cov Y''
  #for(i in 1:m0){
  # for(j in 1:m0){
  #  zv =  function(x) return( Y_2strich(x,i) * Y_2strich(x,j) )
  #  g = function(x) return(zv(x) * dnormix_0(x))
  #  Sigma22[i,j] =  integrate(g,lower=-xrange,upper=xrange)$value
  # }
  #}
  
  
  #berechne Sigma12
  
  #Sigma12 = matrix(NA,nrow=2*m0-1,ncol=m0)
  
  #1 cov delta Y''
  #for(i in 1:(m0-1)){
  # for(j in 1:m0){
  #  zv =  function(x) return( delta(x,i) * Y_2strich(x,j) )
  #  g = function(x) return(zv(x) * dnormix_0(x))
  #  Sigma12[i,j] =  integrate(g,lower=-xrange,upper=xrange)$value
  # }
  #}
  
  #cov Y' Y''
  #for(i in 1:m0){
  # for(j in 1:m0){
  #  zv =  function(x) return( Y_strich(x,i) * Y_2strich(x,j) )
  #  g = function(x) return(zv(x) * dnormix_0(x))
  #  Sigma12[i+m0-1,j] =  integrate(g,lower=-xrange,upper=xrange)$value
  # }
  #}
  
  #Sigma21 = t(Sigma12)
  
  #Sigma22_s <-  Sigma22 - Sigma21 %*% solve(Sigma11) %*% Sigma12
  
  
  
  #return(Sigma22_s)
  
  diagSigma22_s = diag( diag(Sigma22_s)^(-1/2),m0,m0 )
  Sigma22_s_corr = diagSigma22_s %*% Sigma22_s %*% diagSigma22_s

  
  if(m0==1)
    return(c(0.5,0.5))
  
  if(m0==2){
    a=c()
    a[1] = (pi - acos(Sigma22_s_corr[1,2]))/(2*pi)
    a[2] = 0.5
    a[3] = 0.5 - a[1]
    return(a)
  }
  
  if(m0==3){
    a=c()
    
    a[1] = (2*pi - acos(Sigma22_s_corr[1,2])- acos(Sigma22_s_corr[2,3]) - acos(Sigma22_s_corr[1,3]))/(4*pi)
    
    w_stern  = function(i,j,k) return( (Sigma22_s_corr[i,j]- Sigma22_s_corr[i,k]*Sigma22_s_corr[j,k])/sqrt((1-(Sigma22_s_corr[i,k]^2))*(1-(Sigma22_s_corr[j,k]^2))) )
    
    w123 = w_stern(1,2,3)
    w132 = w_stern(1,3,2)
    w231 = w_stern(2,3,1) 
    
    a[2] = (3*pi - acos(w123) - acos(w132) - acos(w231))/(4*pi)
    
    a[3] = 0.5-a[1]
    a[4] = 0.5-a[2]
    
    return(a)  
  }
  
  if(m0>3){
  
    N=10000

    v=matrix(rep(0,(m0+1)*N),ncol=m0+1,nrow=N)

    #f = function(v) return(-1* (2 * t(v) %*% x - t(v) %*% Sigma_s %*% v) )

    for(i in 1:N){

      x = mvrnorm(n = 1, mu=rep(0,m0), Sigma=Sigma22_s)
      #erg = constrOptim(theta=rep(1,2),f=f,ui=diag(2),ci=rep(0,2),grad=NULL)
      #v[i,1:2] = round(erg$par,digits=5)
      erg = solve.QP(Dmat = 2* Sigma22_s, dvec = x, Amat = diag(m0), bvec=rep(0,m0))
      v[i,1:m0] = round(erg$solution,digits=5)
      #print(i)
      temp_anz_gr_null=0
      for(j in 1:m0){
        if(v[i,j]>0) v[i,(m0+1)] = v[i,(m0+1)]+1
      }

    }

    v_anz = v[,(m0+1)]

    a0_sim=0

    for(i in 1:(m0+1)) a0_sim[i] = length(v_anz[v_anz==(i-1)])/N

    return(a0_sim)
  
  }
  
  
}

