em_test_normal_sigma <-
function(dataset, m0, start_param=NA){

  
  start_para_eingabe=0
  if(is.na(start_param[1]))
    start_para_eingabe=F
  

  
  #mean_of_dataset = mean(dataset)
  #dataset = dataset - mean_of_dataset 

  trafo_func     = function(x){
    return(qnorm(x,sd=100))
  }
  
  inv.trafo_func = function(x) {return(pnorm(x,sd=100))}



  #modified Likelihoodfunktion fr k Komponenten
  likelihood.hyp<-function(par,dat,k){
    

      p <- rep(0,k)
      g <- 0
      exp_vec=exp(par[1:(k-1)])
      nenner = 1 + sum(exp_vec)
      for (i in 1:(k-1)) {
        p[i] =  exp(par[i])/nenner
      }

      p[k] = 1 - sum(p[1:(k-1)])
      sigma_temp=c()

      for (i in 1:k) {
		    sigma_temp[i] = inv.trafo_func(par[(k+i-1)]) * sd_max
		    g <- g + p[i] * dnorm(dat,0,sigma_temp[i])
      }

      res <- sum(log(g)) 
      return(res)
      
    
    
  }



  #modified Likelihoodfunktion fr 2*m0 Komponenten
  likelihood.alter<-function(par,dat,k,beta0,eta){

    if(m0==1){
      sigma_tmp =  inv.trafo_func(par) * (eta[2] - eta[1]) + eta[1]
      p = c(beta0,1-beta0)
      g = p[1] * dnorm(dat,mean=0,sd=sigma_tmp[1]) + p[2] * dnorm(dat,mean=0,sd=sigma_tmp[2])
      res <- sum(log(g)) 
      return(res) 
    }
    else{
    #trafo um k gewichte zu erhalten
    p <- rep(0,k)
    exp_vec=exp(par[1:(k-1)])
    nenner = 1 + sum(exp_vec)
    for (i in 1:(k-1)) {
      p[i] =  exp(par[i])/nenner
    }
    p[k] = 1 - sum(p[1:(k-1)])

    #trafo um gewichte ber beta zu splitten
    p1 = p * beta0
    p2 = p * (1-beta0)

    #trafo fr sigmas
    sigma1=0
    sigma2=0
    for(i in 1:k){
        sigma1[i] = inv.trafo_func(par[(k+i-1)]) * (eta[(i+1)] - eta[i]) + eta[i]
        sigma2[i] = inv.trafo_func(par[(2*k+i-1)]) * (eta[(i+1)] - eta[i]) + eta[i]
    }

    g1=0
    g2=0   
    for (i in 1:k) {
        g1 <- g1 + p1[i] * dnorm(dat,mean=0,sd=sigma1[i])
        g2 <- g2 + p2[i] * dnorm(dat,mean=0,sd=sigma2[i])
    }

    g=g1+g2

    res <- sum(log(g)) 
    return(res)
    }
  }

  #versehe likelihood funktionen mit neg. vorzeichen
  minus.like.hyp     <- function(par,dat,k) { - likelihood.hyp(par,dat,k)}
  minus.like.alter   <- function(par,dat,k,beta0,eta) { - likelihood.alter(par,dat,k,beta0,eta)}

  ##########################################
  #                                        #
  #     Schtzung Parameter unter H0       #
  #                                        #
  ##########################################

  if(m0==1){
  
    par_est.hyp=c(1,sd(dataset))
    start_param=par_est.hyp
    
    erg.hyp = list( minimum =  -sum(log(dnorm(dataset,0,sd(dataset)))) )
    
    #print(erg.hyp)
    
  
  }
  else{

  #sd_max=3*sd(dataset)
  sd_max=4*sd(dataset)

  #falls kein Start-Parameter bergeben wurde -> schtze mit Nelder-Mead zuerst und nehme das Ergebnis als start_para fr nlm
  if(is.na(start_param[1]) || length(start_param)!= (2*m0-1)){
   
   #print("Kein Startpatrameter fr Optimierung bergeben!")
    
   #NB unter Hyp
   M.hyp = rbind(diag(2*m0-1),c(rep(-1,m0-1),rep(0,m0)), cbind(matrix(rep(0,m0*(m0-1)),ncol=m0-1), -diag(m0) ) )
   c.hyp=c(rep(0,m0-1),rep(0,m0),-1,rep(-sd_max,m0))
           
   start_param=rep(1/m0,m0-1)
	 temp_seq = seq(from=0,to=sd_max,by=sd_max/(m0+1))
	 start_param[m0:(2*m0-1)] = temp_seq[2:(m0+1)]
	 #print(start_param)
	 
   likelihood.hyp_nelder<-function(par){
      p <- par[1:(m0-1)]
      g <- 0
      p[m0] = 1 - sum(p[1:(m0-1)])
	    sigma_temp=par[m0:(2*m0-1)]
	  
      for (i in 1:m0) {
		    g <- g + p[i] * dnorm(dataset,0,sigma_temp[i])
      }

      res <- sum(log(g))
      return(-res)
   }

   erg.hyp_nelder=constrOptim(theta=start_param,f=likelihood.hyp_nelder,grad=NULL,ui=M.hyp,ci=c.hyp)
   
   start_param = erg.hyp_nelder$par

	
  }
  
  #print(start_param)
    
  #transformiere startparameter zu startvector fr die Optimierung
  nenner = 1-sum(start_param[1:(m0-1)])
  start_vec.hyp = 0
  for(i in 1:(m0-1)){
    start_vec.hyp[i] = log(start_param[i]/nenner)
  }
  

  #in optimierung beschrnken wir auch hier die sigmas auf kompaktes intervall (allerdings hier gemeinsames fr alle) -> daher hier diese trafo
  start_vec.hyp[m0:(2*m0-1)] = trafo_func(start_param[(m0):(2*m0-1)] / sd_max )
  
  #print(start_vec.hyp)

  #optimiere log likelihood (minus log like wird minimiert)
  erg.hyp <- nlm(minus.like.hyp, p=start_vec.hyp, dat=dataset,k=m0) 

  #rcktransformation der werte
  par_est.hyp=0
  exp_vec=exp(erg.hyp$estimate[1:(m0-1)])
    nenner = 1 + sum(exp_vec)
    for (i in 1:(m0-1)) {
      par_est.hyp[i] =  exp(erg.hyp$estimate[i])/nenner
    }
  
  par_est.hyp[m0] = 1 - sum(par_est.hyp[1:(m0-1)])
  
  
  par_est.hyp[(m0+1):(2*m0)] = inv.trafo_func(erg.hyp$estimate[(m0):(2*m0-1)]) * sd_max 
  
  
  #speichere werte  
  p0_dach    = par_est.hyp[1:m0]
  sigma_dach = par_est.hyp[(m0+1):(2*m0)]
  
  #ordne thetas
  d=data.frame(sigma_dach,p0_dach)
  d=d[order(d$sigma_dach),]
  p0_dach    = d$p0_dach
  sigma_dach = d$sigma_dach

  par_est.hyp=c(p0_dach,sigma_dach)
  
  #print(round(par_est.hyp,digit=2))
  #print(-erg.hyp$minimum )
  
  } # ende von fall m0>1
  
  ##########################################
  #                                        #
  #    Schtzung unter eingschr. Altern.   #
  #                                        #
  ##########################################
  
  
  s1_alter = start_param[m0:(2*m0-1)]
  s2_alter = start_param[m0:(2*m0-1)]
  
  delta_alter = seq(-0.03,0.03,0.06/(2*m0-1))
  
  #stre die start support points points
  for(i in 1:m0){ 
	 j=2*i
	 s1_alter[i] = s1_alter[i] + delta_alter[j-1]
	 s2_alter[i] = s2_alter[i] + delta_alter[j]	
  }
  
  if(m0!=1)
    start_param.alter=c(start_param[1:(m0-1)],(1-sum(start_param[1:(m0-1)])),s1_alter,s2_alter)
  else
    start_param.alter=c(sd(dataset)+delta_alter[1],sd(dataset)+delta_alter[2])
  
  
  if(!start_para_eingabe && (m0!=1) ){
    s1_alter = sigma_dach
    s2_alter = sigma_dach
    for(i in 1:m0){ 
      j=2*i
	   s1_alter[i] = s1_alter[i] + delta_alter[j-1]
	   s2_alter[i] = s2_alter[i] + delta_alter[j]	
    }
    start_param.alter=c(p0_dach,s1_alter,s2_alter)   
  }
  
  #erstelle Intervallgrenzen "eta"
  eta=0
  eta[1] = 0
  sdach  = 0
  if(m0!=1){
    for( i in 1:(m0-1)){
	     sdach[i+1] = min(s1_alter[i+1],s2_alter[i+1])
	     sdach[i] =   max(s1_alter[i],s2_alter[i])	
	     eta[i+1] = ( sdach[(i+1)] + sdach[i] )/2
    }
    eta[m0+1] = 2 * max(par_est.hyp)
  
    #transformiere startparameter fr die Optimierung (Gewichte)
    nenner = 1-sum(start_param.alter[1:(m0-1)])
    start_vec.alter = 0
    for(i in 1:(m0-1)){
      start_vec.alter[i] = log(start_param.alter[i]/nenner)
    }

    for(i in 1:m0){
      start_vec.alter[(i+m0-1)] = trafo_func( (start_param.alter[m0+i]-eta[i])/(eta[(i+1)] - eta[i]) )
    }
    for(i in 1:m0){
      start_vec.alter[(i+2*m0-1)] = trafo_func( (start_param.alter[2*m0+i]-eta[i])/(eta[(i+1)] - eta[i]) )
    }
  }
  else{
    eta[2] = 3*sd(dataset)
    start_vec.alter = 0
    start_vec.alter = trafo_func( (start_param.alter-eta[1])/(eta[2] - eta[1]) )
  }


  #whle betas
  bbeta=c()

  for(h in 1:m0) {
  bbeta=rbind(cbind(bbeta, rep(0.1, 3^{h-1} ) ),
           cbind(bbeta, rep(0.3, 3^{h-1} ) ),
           cbind(bbeta, rep(0.5, 3^{h-1} ) ) )
  }

  N = dim(bbeta)[1]
  
  #fhre fr jedes beta optimierung durch -> whle optimales anschlieend
  liste_erg.alter =list()
  werte =0
  
  for(j in 1:N){
    #optimiere eingeschrnkte likelihood-funktion
    liste_erg.alter[[j]] <- nlm(minus.like.alter, p=start_vec.alter, dat=dataset,k=m0,beta0=bbeta[j,],eta=eta)
    werte[j] = liste_erg.alter[[j]]$minimum
  }
  
  j0 = which.min(werte)
  
  beta0 = matrix(as.vector(bbeta[j0,]),nrow=1)
  
  erg.alter = liste_erg.alter[[j0]]
  par_est.alter = erg.alter$estimate

  #rcktransformation der werte
  p=0

  #trafo fr p
  exp_vec=exp(par_est.alter[1:(m0-1)])
  nenner = 1 + sum(exp_vec)
  for (i in 1:(m0-1)) {
    p[i] =  exp(par_est.alter[i])/nenner
  }
  p[m0] = 1 - sum(p[1:(m0-1)])


  p1 = p * beta0
  p2 = p * (1-beta0)

  #trafo fr sigmas
  sigma1=0
  sigma2=0
  for(i in 1:m0){
    sigma1[i] = inv.trafo_func(par_est.alter[(m0+i-1)]) * (eta[(i+1)] - eta[i]) + eta[i]
    sigma2[i] = inv.trafo_func(par_est.alter[(2*m0+i-1)]) * (eta[(i+1)] - eta[i]) + eta[i]
  }
  

    
  #abspeichern der Log-Likelihoodwerte und Teststatistik ohne EM Iteration
  log_like.alter = -erg.alter$minimum 
  log_like.hyp   = -erg.hyp$minimum 
  LR = 2*(log_like.alter - log_like.hyp)
  
  #Berechnungen fr p-wert:
  #1: gewichte der asymptotischen chi^2 mischung
  a0=0
  if(m0==1)
    a0=c(.5,.5)
  else
    a0 = calc_weights(p0=par_est.hyp[1:m0],theta0 = par_est.hyp[(m0+1):(2*m0)])
  
  #2: entsprechende asymptotische Verteilungsfunktion
  cdf_teststat = function(x){
    if(x<0) return(0)
    else{
      m  = c()
      m[1] = a0[1]
      for (i in 2:(m0+1)){
        m[i] = a0[i] * pchisq(x, (i-1))
      }
      return(sum(m))
    }
  }
  
  #3: p-wert berechnen
  p_wert = 1-cdf_teststat(LR)
  
  p_est_alter = c(p1,p2)
  sigma_est_alter = c(sigma1,sigma2)
  
  d_alter=data.frame(sigma_est_alter,p_est_alter)
  d_alter=d_alter[order(d_alter$sigma_est_alter),]
  p0_dach_alter    = d_alter$p_est_alter
  sigma_dach_alter = d_alter$sigma_est_alter
  
  test_obj = new("EM-Test",data=dataset,mean_data=mean(dataset),m0=m0,p_value=p_wert,LR=LR,loglikelihood_alter=log_like.alter,loglikelihood_hyp=log_like.hyp,mle_hyp=par_est.hyp,mle_alter=c(p0_dach_alter,sigma_dach_alter))
  
  return(test_obj)
  
  
}

