#OOP mit S4

#definiere Klasse
setClass("EM-Test",representation = representation(data="numeric",mean_data="numeric",m0="numeric",p_value="numeric",LR="numeric",loglikelihood_alter="numeric",loglikelihood_hyp="numeric",mle_alter="numeric",mle_hyp="numeric"))

#definiere show, bzw. printfunktion um fr Objekte dieser Klasse
setMethod("show",signature(object="EM-Test"),
  function(object){  
    cat("\nTesting the number of Regimes")
    cat("\n \tP-Value: \t\t\t\t",object@p_value)
    cat("\n \tlikelihood ratio:\t\t\t",object@LR)
    cat("\n \tlog-likelihood value hypothesis:\t",object@loglikelihood_hyp)
    cat("\n \tlog-likelihood value alternative:\t",object@loglikelihood_alter,"\n")
    cat("\nmaximum likelihood estimate hypothesis (",object@m0,"regimes )")
    cat("\n \tweights:",round(object@mle_hyp[1:object@m0],digits=4))
    cat("\n \tsigmas:\t",round(object@mle_hyp[(object@m0+1):(2*object@m0)],digits=4),"\n")
    cat("\nmaximum likelihood estimate alternative (",2*object@m0,"regimes )")
    cat("\n \tweights:",round(object@mle_alter[1:(2*object@m0)],digits=4))
    cat("\n \tsigmas:\t",round(object@mle_alter[(2*object@m0+1):(4*object@m0)],digits=4),"\n")
    
  }
)



#berschreibe plot funktion
setMethod("plot",signature("EM-Test"),
  definition = function(x,y=NULL){

  

    dnormix_hyp   <- function(z) {  
      erg=0
      m0=x@m0
      theta0=x@mle_hyp[(x@m0+1):(2*x@m0)]
      p0= x@mle_hyp[1:x@m0]
      for (i in 1:m0)
        erg = erg + p0[i]* dnorm(z,mean=0,sd=theta0[i])
      return(erg)
    }
    
    dnormix_alter   <- function(z) {  
      erg=0
      m0=x@m0
      theta0=x@mle_alter[(2*x@m0+1):(4*x@m0)]
      p0=x@mle_alter[1:(2*x@m0)]
      for (i in 1:(2*m0))
        erg = erg + p0[i]* dnorm(z,mean=0,sd=theta0[i])
      return(erg)
    }
    

  #hist(x@data, freq=T)
  curve(dnormix_hyp,xlim=c(mean(x@data)-4*sd(x@data),mean(x@data)+4*sd(x@data)),col="blue",lwd=1,n=1000)
  curve(dnormix_alter,add=T,col="red",lwd=1,n=1000)
  lines(density(x@data),lty=2,lwd=1)
  
  legend(mean(x@data)-3*sd(x@data)+0.05, dnormix_hyp(mean(x@data)), c("f.hyp", "f.alter", "emp. density"), col = c("blue","red","black"),
       text.col = "black", lty = c(1, 1, 2),merge = TRUE,cex=0.8)


  }
)
