\name{calc_weights}
\alias{calc_weights}

\title{
Estimating the weights of the asymptotic \eqn{\chi^2}-mixture of the test statistic
}
\description{
The asymptotic distribution of the likelihood ratio is (under null hypothesis) a mixture of m0+1 \eqn{\chi^2} distributions and depends on the parameters of the null distribution of the data. This function calculates these weights. Since we can estimate the parameters consistently, we can replace them by the mle under the hypothesis. 
}
\usage{
calc_weights(p0, theta0)
}

\arguments{
  \item{p0}{
true or estimated weights of the normal mixture
}
  \item{theta0}{
true or estimated standard deviations of the normal mixture
}
}
\value{
weights of the asymptotic \eqn{\chi^2}-mixture of the test statistic
}



\examples{
calc_weights(p0=c(0.5,0.5),theta0=c(1,5))
}

