\name{em_test_normal_sigma}
\alias{em_test_normal_sigma}

\title{
Testing the number of regimes in a Hidden Markov Model
}
\description{
The function implements a likelihood ratio based test for the number of regimes of a Hidden Markov Model (HMM). It tests the hypothesis of m0 regimes versus the alternative of 2*m0 regmies by calculating the mle's with the likelihood function under independence. The test statistic converges (under null hypothesis) in distribution to 
\deqn{\alpha_0 \chi_0^2 + \ldots + \alpha_{m0} \chi_{m0}^2,}
where \eqn{\chi_0^2} is a point mass a zero and \eqn{\chi_k^2} a chi-square distribution with k degrees of freedom. The weights \eqn{\alpha_k} a calculated by the function \code{\link{calc_weights}} in dependece of the estimation under the hypothesis. 
For further details see the paper below.

If you use return time series you should rescale them to percentage values.
}
\usage{
em_test_normal_sigma(dataset, m0, start_param = NA)
}

\arguments{
  \item{dataset}{
the given dataset
}
  \item{m0}{
number of regimes under the hypothesis
}
  \item{start_param}{
optionally a starting value for the optimisation c(p_1,...p_(m0-1),sigma_1,...,sigma_m0)
}
}

\value{
returns an object of class EM-Test (see: \code{\link{EM-Test-class}})
}
\references{
cite paper EM-Test for HMM
}


\examples{
  x = c(rnorm(500,sd=1),rnorm(500,sd=5),rnorm(500,sd=10))
  erg = em_test_normal_sigma(x,2)
  erg
  plot(erg)
}
