\name{norm.HMM.mle}
\alias{norm.HMM.mle}

\title{
Fittig the parameters of a Normal Hidden Markov Model
}
\description{
Estimates the parameters of the model using numerical minimization of the negative log likelihood.
}
\usage{
norm.HMM.mle(x, m, sigma0, gamma0, ...)
}

\arguments{
  \item{x}{
sample
}
  \item{m}{
number of states of the hidden Markov chain
}
  \item{sigma0}{
starting parameters for the minimization (vector of length m)
}
  \item{gamma0}{
starting parameters for the minimization (mxm-Matrix)
}
  \item{\dots}{
...
}
}

\value{
The returned value is a list with components:
  \item{sigma}{MLE for the state dependent variances}
  \item{gamma}{MLE for the tpm}
  \item{delta}{MLE for the initianl distribution of the hidden Markov chain}
  \item{code}{an integer indicating why the optimization process in nlm() terminated}
  \item{mllk}{(negative) maximum value of the log likelihood}
  \item{AIC}{Information criterion (AIC)}
  \item{BIC}{Information criterion (BIC)}

}
